#!/usr/bin/perl

require "codelib.pl";
require "gifsave.pl";
require "cgi-lib.pl";

$ENV{'HBFPATH'} = "./fonts";
use HBF;

&ReadParse(*values);

$cfontname = $values{'cfontname'};
$encoding = $values{'encoding'};
$ctext = $values{'ctext'};
$bgcolor = $values{'bgcolor'};
$fgcolor = $values{'fgcolor'};
$bottommargin = $topmargin = $values{'topmargin'};
$leftmargin = $rightmargin = $values{'leftmargin'};

if ($encoding eq "autodetect") {
    @guesses = codeguess($ctext);
    if ($guesses[0] eq "big5") {
	$encoding = "big5";
    } elsif ($guesses[0] eq "gb") {
	$encoding = "gb";
    } elsif ($guesses[0] eq "utf8") {
	$encoding = "utf8";
    } else {
        print "Content-type: text/plain\n\nUnknown encoding. Please select GB, Big5, or UTF-8\n";
        exit;
    }
}


# Values for testing
#$cfontname = "chinese16";
#$encoding = "big5";
#$ctext = "";
#$fgcolor = "0,0,0";
#$bgcolor = "255,255,255";


# Start creating the GIF
$efont = new HBF;
if ($cfontname =~ m/16/) {
  $efont->loadFont("8x16");
} elsif ($cfontname =~ m/24/) {
  $efont->loadFont("12x24");
}

$cfont = new HBF;
$cfont->loadFont($cfontname);

if ($topmargin == 0) {
   $bottommargin = $topmargin = 24;
}
if ($leftmargin == 0) {
   $rightmargin = $leftmargin = 24;
}

if ($encoding eq "utf8") {
    $ctext = utf82ucs($ctext);
}

if ($ctext =~ m#^\s*(http|gopher|ftp)://#) {
  chomp($ctext);
  open(WEB, "./lynx -assume_charset=big5 -dump $ctext |");
  while (<WEB>) {
    chomp; chomp;
    push @lines, $_;
  }   
  close(WEB);
} else {
  @lines = split(/\r\n/, $ctext);
}


$curx = $leftmargin; $cury = $topmargin;

foreach $line (@lines) {
#    last if $linecount++ > 30;
    #print STDERR $line;
    for ($k = 0; $k < length($line); $k++) {
	if (vec(substr($line, $k, 1), 0, 8) <= 127) {
	    # Latin Char, use English font
	    $mydata = $efont->getChar(pack("C", 0x00) . substr($line, $k, 1));
	    for ($i = 0; $i < $efont->{'height'}; $i++) {
		for ($j = 0; $j < $efont->{'width'}; $j++) {
		    if (substr($mydata, $i * (8 * int(($efont->{'width'}+7)/8)) + $j, 1) 
			eq "1") {
			&PutPixel($curx + $j, $cury + $i, 1);
			#print STDERR "*";
		    } #else { print STDERR " "; }
		}
		#print STDERR "\n";
	    }
	    $curx += $efont->{'width'} + $x_space;
	    if ($curx > $gifwidth) { $gifwidth = $curx; }
	} else {
	    $mydata = $cfont->getChar(substr($line, $k, 2));
	    for ($i = 0; $i < $cfont->{'height'}; $i++) {
		for ($j = 0; $j < $cfont->{'width'}; $j++) {
		    if (substr($mydata, $i * (8 * int(($cfont->{'width'}+7)/8)) + $j, 1) 
			eq "1") {
			&PutPixel($curx + $j, $cury + $i, 1);
		#	print STDERR "*";
		    } # else { print STDERR " ";}
		}
	        #print STDERR "\n";
	    }
	    $curx += $cfont->{'width'} + $x_space;
	    if ($curx > $gifwidth) { $gifwidth = $curx; }
	    $k++;
	}
    }
    $curx = $leftmargin;
    $cury += $cfont->{'width'} + $y_space;
    if ($cury > $gifheight) { $gifheight = $cury; }
}

#$rightmargin = 12;
#$bottommargin = 12;

print "Content-type: image/gif\n\n";

&GIF_Create("STDOUT", $gifwidth + $rightmargin, $gifheight +
$bottommargin, 2, 8);

($red, $green, $blue) = split(/,/, $bgcolor);
&GIF_SetColor(0, $red, $green, $blue);
($red, $green, $blue) = split(/,/, $fgcolor);
&GIF_SetColor(1, $red, $green, $blue);

&GIF_CompressImage(0, 0, -1, -1);

exit(0);
